/**
   The prettyPrint() method takes a BTree and
   converts it into a well formated string.

   This prettyPrint() method should print a binary tree
   so that the root of a sub tree and the root of the sub
   tree's left child are on the same line (see the examples
   in the file output.txt). In addition, if the sub tree is
   small, and has depth one, then the whole sub tree should
   be printed on a single line (as in homework assignment 1).
   Finally, the closing parentheses should lumped together
   as much as possible (again, see the examples).
*/

public class PrettyPrinter
{
   public static String prettyPrint(BTree tree)
   {
      return prettyPrint(tree, "", false);
   }

   /**
      This prettyPrint() method is essentially a
      preorder traversal of the tree.
   */
   private static String prettyPrint(BTree tree, String indentation, boolean inline)
   {
      String result = "";

      if (tree == null)  // empty tree (stops the recursion)
      {
         if (inline)
            result += "()";
         else
            result += indentation + "()";
      }
      else if (tree.depth() == 0)
      {
         if (inline)
            result += tree.getElement();
         else
            result += indentation + tree.getElement();
      }
      else if (tree.depth() == 1)
      {
         if (inline)
            result += "(" + tree.getElement();
         else
            result += indentation + "(" + tree.getElement();
         result += prettyPrint( tree.getLeftTree(),  " ", false );
         result += prettyPrint( tree.getRightTree(), " ", false );
         result += ")";
      }
      else
      {
         if (inline)
            result += "(" + tree.getElement() + " ";
         else
            result += indentation + "(" + tree.getElement() + " ";
         String temp = "";
         for (int i = 0; i < tree.getElement().length(); i++) { temp += " "; }
         result += prettyPrint( tree.getLeftTree(),  temp+indentation+"  ", true ) + "\n";
         result += prettyPrint( tree.getRightTree(), temp+indentation+"  ", false ) + ")";
      }

      return result;
   }
}//PrettyPrinter